#ifndef _VPWINI_C
#define _VPWINI_C
//----------------------------------------------------------------------
// vpwini.c _VPW_VERSIONSTRING
// (c) copyright Enrico Sorichetti, 2004-2007
// Released under the "Q Public license"
//----------------------------------------------------------------------
//

#undef	_VPW_MAIN
#include "vpwpc.h"

#define _VPW_MASK(mz,pz) \
	do 	{ \
		strcpy( maskname[maskcoun] , mz ) ; \
		maskpatt[maskcoun][0] = '\0' ; \
		if 	( strlen(spooldir) > 0 ) { \
			strcat( maskpatt[maskcoun], spooldir ) ; \
			strcat( maskpatt[maskcoun], "/") ; \
		} \
		strcat(maskpatt[maskcoun], pz ) ; \
		maskcoun++ ; \
	} while (0) 
																
void vpwini(void)
{

    int  i, j, l;
	char c, s ;
    int rc;

	int tempcoun ;

    char kword[_VPW_CHARS21];
	char fmask[_VPW_CHARS257];
    char value[_VPW_CHARS257];

//	defaults
	_VPW_MASK( "job_p",	"jesclas/jobname_jobnumb_dupindx.pdf" );
	_VPW_MASK( "job_s", "jesclas/prgname_jobname.pdf" );
	_VPW_MASK( "job",	"jesclas/jobname_jobnumb_dupindx.txt " );
	_VPW_MASK( "stc_p",	"stc/jobname_jobnumb_dsnindx.pdf" );
	_VPW_MASK( "stc",	"stc/jobname_jobnumb_dsnindx.txt" );
	_VPW_MASK( "tsu",	"tso/jobname_jobnumb_dsnindx.txt" );
	_VPW_MASK( "*",		"jesclas/jobname_jobnumb_dsnindx.txt" );

	strcpy(dfltmask,"*") ;
	dfltpatt[0] = '\0' ;  
	if 	( strlen(spooldir) > 0 ) { \
		strcat( dfltpatt, spooldir ) ; \
		strcat( dfltpatt, "/") ; \
	} \
	strcat(dfltpatt, "junk/jobname_jobnumb_dsnindx.txt") ; 

//	defaults end

	if (ini0 != NULL) {
		
		tempcoun = 0;
		for (;;) {
			fgets(ini0buff, _VPW_BUFF1024, ini0);
			if (feof(ini0))
				break;

			for (j = 0;
				 j < _VPW_BUFF1024 && ini0buff[j] != '\0'
				 && ini0buff[j] != '\n' && ini0buff[j] != '\r'; j++);
			ini0buff[j + 0] = '\0';

			ini0lbuf = strlen(ini0buff) ;

			if (ini0lbuf == 0)
				continue;

			if (strchr(";#", ini0buff[0]))
				continue;
			
			j = 0 ;
			/* skip blanks */
			for (; (ini0buff[j] == ' ') || (ini0buff[j] == '\t') ; j++);

			kword[0] = '\0';
			fmask[0] = '\0';
			value[0] = '\0';

			for (i = 0 ; j < ini0lbuf
				 && ini0buff[j] != ' ' && ini0buff[j] != '\t' 
				 && ini0buff[j] != ';' && ini0buff[j] != '#'
				 && ini0buff[j] != '\0'; kword[i++] = ini0buff[j++]);
			kword[i + 0] = '\0';
			for (i = 0; kword[i] != '\0'; i++)
				kword[i] = tolower(kword[i]);
			j++ ;

			/* skip blanks */
			for (; (ini0buff[j] == ' ') || (ini0buff[j] == '\t') ; j++);

			for (i = 0; j < ini0lbuf
				 && ini0buff[j] != ' ' && ini0buff[j] != '\t' 
				 && ini0buff[j] != ';' && ini0buff[j] != '#'
				 && ini0buff[j] != '\0'; fmask[i++] = ini0buff[j++]);
			fmask[i + 0] = '\0';
			for (i = 0; fmask[i] != '\0'; i++)
				fmask[i] = tolower(fmask[i]);
			j++ ;

			/* skip blanks */
			for (; (ini0buff[j] == ' ') || (ini0buff[j] == '\t') ; j++);

			for (i = 0; j < ini0lbuf
				 && ini0buff[j] != ' ' && ini0buff[j] != '\t' 
				 && ini0buff[j] != ';' && ini0buff[j] != '#'
				 && ini0buff[j] != '\0'; value[i++] = ini0buff[j++]);
			value[i + 0] = '\0';
			for (i = 0; value[i] != '\0'; i++)
				value[i] = tolower(value[i]);

			if ( strcasecmp(kword,"datelong") == 0 ) {
				datelong = 1 ;
				continue ;
			}

			if ( strcasecmp(kword,"datepref") == 0 ) {
				strcpy(datepref,fmask) ;
				continue ;
			}

			if ( strcasecmp(kword,"timelong") == 0 ) {
				timelong = 1 ;
				continue ;
			}

			if ( strcasecmp(kword,"timepref") == 0 ) {
				strcpy(timepref,fmask) ;
				continue ;
			}

			if ( strcasecmp(kword,"prgrname") == 0 ) {
				strcpy(prgrname,fmask) ;
				continue ;
			}

			if ( strcasecmp(kword,"2chars") == 0 ) {
				stdwidth = _VPW_2CHARS;
				continue ;
			}

			if ( strcasecmp(kword,"3chars") == 0 ) {
				stdwidth = _VPW_3CHARS;
				continue ;
			}

			if ( strcasecmp(kword,"fmask") == 0 ) { 
				strcpy(maskname[tempcoun],fmask) ; \
				strcpy(maskpatt[tempcoun],value) ; \
				tempcoun++; 
				continue ;
			}
			
			fprintf(stderr, "%-8s - Invalid 'IniFile' record \n         - \"%s\" \n",
							prog, ini0buff);
		}

		if 	( tempcoun > 0 ) 
			maskcoun = tempcoun ;

		fclose(ini0);
	}

	if ( log0 ) {
        fprintf(log0,	"%s - %-8s patterns / options\n", log0time, prog);

        for (i = 0; i < maskcoun; i++) {
			fprintf(log0,	"%s - %-8s %-25s '%s'.\n", log0time, " ", maskname[i], maskpatt[i]);
	    }

		fprintf(log0,	"%s - %-8s %-25s '%d'.\n", log0time, " ", "datelong", datelong);
		fprintf(log0,	"%s - %-8s %-25s '%s'.\n", log0time, " ", "datepref", datepref);
		fprintf(log0,	"%s - %-8s %-25s '%d'.\n", log0time, " ", "timelong", timelong);
		fprintf(log0,	"%s - %-8s %-25s '%s'.\n", log0time, " ", "timepref", timepref);
		fprintf(log0,	"%s - %-8s %-25s '%d'.\n", log0time, " ", "stdwidth", stdwidth);
		fprintf(log0,	"%s - %-8s %-25s '%s'.\n", log0time, " ", "prgrname", prgrname);
	}

	return ;
}

#endif
