#ifndef _VPWPARS_C
#define _VPWPARS_C
//----------------------------------------------------------------------
// vpwpars.c _VPW_VERSIONSTRING
// (c) copyright Enrico Sorichetti, 2004-2007
// Released under the "Q Public license"
//----------------------------------------------------------------------
//

#undef  _VPW_MAIN
#include "vpwpc.h"

int vpwpars(const char *hasp_buff)
{
    int type;

    int i, j, l;
    int ii, jj, ll;

    int wyear, wmnth, wdays;
    int whour, wmins, wsecs;

    char buff[_VPW_BUFF1024];
    char temp[_VPW_CHARS257];
    char tokn[_VPW_CHARS257];

    // Beginning of
    // "The Horrid hack "
    // due to the presence in the sysout files of
    // dangling control characters

    for (j = 0;
         hasp_buff[j] == '\f' ||
         hasp_buff[j] == '\n' || hasp_buff[j] == '\r';
         j++);
    // printf("%-8s - vpwpars skipped (%d) cntl chars.\n", prog, j);

    for (i = 0;
		j < _VPW_BUFF1024 &&
		hasp_buff[j] != '\0' && hasp_buff[j] != '\n' && hasp_buff[j] != '\r';
		buff[i++] = hasp_buff[j++]);
    buff[i + 0] = '\0';
    // printf("%8s - vpwpars buffer shifted.\n", prog);

    // end of :
    // " The Horrid hack "

    /* (****) */
    for (i = 0, j = _VPW_TRIGGER_OFF, jj = _VPW_TRIGGER_OFF_2;
         i < _VPW_TRIGGER_LEN; i++, j++, jj++) {
        if (trigger[i] != buff[j])
            return _VPW_JES_DATA ;
        if (buff[j] != buff[jj])
            return _VPW_JES_DATA ;
    }
    // printf("%8s - vpwpars OK stars\n", prog);

    /* (ROOM) */
    for (i = 0, j = _VPW_TAGROOM_OFF; i < _VPW_TAGROOM_LEN; i++, j++)
        if (tagroom[i] != buff[j])
            return _VPW_JES_DATA ;
    // printf("%8s - vpwpars OK tagroom\n", prog);

    /* (PRINTER) */
    for (i = 0, j = _VPW_TAGUNIT_OFF; i < _VPW_TAGUNIT_LEN; i++, j++)
        if (tagunit[i] != buff[j])
            return _VPW_JES_DATA ;
    // printf("%8s - vpwpars OK tagunit\n", prog);

    /* (SYS) */
    for (i = 0, j = _VPW_TAGXSYS_OFF; i < _VPW_TAGXSYS_LEN; i++, j++)
        if (tagxsys[i] != buff[j])
            return _VPW_JES_DATA ;
    // printf("%8s - vpwpars OK tagxsys\n", prog);

    /* START / END / CONT */
    for (j = _VPW_HDRTYPE_OFF; buff[j] == ' '; j++);
    for (jj = _VPW_HDRTYPE_OFF_2; buff[jj] == ' '; jj++);
    for (i = 0; i < _VPW_HDRTYPE_LEN && buff[j] != ' ' && buff[jj] != ' ';
         i++, j++, jj++)
        if (buff[j] != buff[jj])
            return _VPW_JES_DATA ;
        else
            tokn[i] = buff[j];
    tokn[i + 0] = '\0';
    // printf("%8s - vpwpars hasp trig :%s\n", prog, tokn);

    if (strcasecmp(tokn, "END") == 0)
        return _VPW_JES_END ;

    type = _VPW_JES_DATA ;
    for (i = 0; i < _VPW_JESTYPES; i++)
        if (strcasecmp(types[i], tokn) == 0) {
            type = i + 1 ;
            break;
        }
    if ( type == _VPW_JES_DATA )
        return _VPW_JES_DATA ;
    // printf("%8s - vpwpars OK hasp trig :%c\n", prog, type);

    /* SYSOUT CLASS */
    for (i = 0, j = _VPW_JESCLAS_OFF, jj = _VPW_JESCLAS_OFF_2;
         i < _VPW_JESCLAS_LEN; i++, j++, jj++)
        if (buff[j] != buff[jj])
            return _VPW_JES_DATA ;
        else
            tokn[i] = buff[j];
    tokn[i + 0] = '\0';
    strcpy(values[_VPW_JESCLAS], tokn);
    // printf("%8s - vpwpars OK jesclas :%s\n", prog, values[_VPW_JESCLAS]);

    /* _VPW_JOBNUMB */
    for (i = 0, j = _VPW_JOBNUMB_OFF, jj = _VPW_JOBNUMB_OFF_2;
         i < _VPW_JOBNUMB_LEN; i++, j++, jj++)
        if (buff[j] != buff[jj])
            return _VPW_JES_DATA ;
        else
            tokn[i] = buff[j];
    tokn[i + 0] = '\0';
    for (i = 0; tokn[i] != '\0'; i++) {
        if (tokn[i] == ' ')
            tokn[i] = '0';
    }
    strcpy(values[_VPW_JOBNUMB], tokn);
    // printf("%8s - vpwpars OK jobnumb :%s\n", prog, values[_VPW_JOBNUMB]);

    tokn[_VPW_JOBTYPE_LEN] = '\0';
    strcpy(values[_VPW_JOBTYPE], tokn);
    // printf("%8s - vpwpars OK jobtype :%s\n", prog, values[_VPW_JOBTYPE]);

    /* _VPW_JOBNAME */
    for (i = 0, j = _VPW_JOBNAME_OFF;
         i < _VPW_JOBNAME_LEN && buff[j] != ' '; tokn[i++] = buff[j++]);
    tokn[i + 0] = '\0';
    strcpy(values[_VPW_JOBNAME], tokn);
    // printf("%8s - vpwpars OK jobname :%s\n", prog, values[_VPW_JOBNAME]);

    /* PROGRAMMER'S NAME */
    for (i = 0, j = _VPW_PRGNAME_OFF;
         i < _VPW_PRGNAME_LEN && buff[j] != ' '; tokn[i++] = buff[j++]);
    tokn[i + 0] = '\0';
	if	( strlen(tokn) > 0 )
    	strcpy(values[_VPW_PRGNAME], tokn);
	else
    	strcpy(values[_VPW_PRGNAME], prgrname);
//	printf("%8s - vpwpars OK prgname :%s\n", prog, values[_VPW_PRGNAME]);

    /* ROOM NUMBER */
    for (i = 0, j = _VPW_JESROOM_OFF;
         i < _VPW_JESROOM_LEN && buff[j] != ' '; tokn[i++] = buff[j++]);
    tokn[i + 0] = '\0';
    strcpy(values[_VPW_JESROOM], tokn);
    // printf("%8s - vpwpars OK jesroom :%s\n", prog, values[_VPW_JESROOM]);

    /* JES DATE */
    /* year */
    for (j = _VPW_JESDATE_OFF; buff[j] == ' '; j++);
    for (i = 0; i < 2 && buff[j] != ' '; temp[i++] = buff[j++]);
    temp[i + 0] = '\0';
    wdays = atoi(temp);
    j++;
    /* month */
    for (; buff[j] == ' '; j++);
    for (i = 0; i < 3 && buff[j] != ' '; temp[i++] = buff[j++]);
    temp[i + 0] = '\0';
    for (wmnth = 0;
         wmnth < _VPW_KMONTHS && strcasecmp(months[wmnth], temp) != 0;
         wmnth++);
    wmnth++;
    j++;
    /* day */
    for (; buff[j] == ' '; j++);
    for (i = 0; i < 2 && buff[j] != ' '; temp[i++] = buff[j++]);
    temp[i + 0] = '\0';
    wyear = atoi(temp);

	if ( datelong == 1 ) {
    	if (wyear < 50)
        	wyear = wyear + 2000;
    	else
        	wyear = wyear + 1900;
    	snprintf(tokn, _VPW_CHARS257, "%s%4d%2d%2d", datepref, wyear, wmnth, wdays);
	}
	else
    	snprintf(tokn, _VPW_CHARS257, "%s%2d%2d%2d", datepref, wyear, wmnth, wdays);

    for (i = 0; tokn[i] != '\0'; i++) {
        if (tokn[i] == ' ')
            tokn[i] = '0';
	}

    strcpy(values[_VPW_JESDATE], tokn);

    /* JES TIME */
    /* hours */
    for (j = _VPW_JESTIME_OFF; buff[j] == ' '; j++);
    for (i = 0;
         i < 2 && buff[j] != ' ' && buff[j] != '.'; temp[i++] = buff[j++]);
    temp[i + 0] = '\0';
    j++;
    whour = atoi(temp);
    if (whour == 12)
        whour = 0;
    if (buff[_VPW_JESTIME_OFF+ 9] == 'P')
        whour = whour + 12;
    /* minutes */
    for (i = 0;
         i < 2 && buff[j] != ' ' && buff[j] != '.'; temp[i++] = buff[j++]);
    temp[i + 0] = '\0';
    j++;
    wmins = atoi(temp);
    /*seconds */
    for (i = 0;
         i < 2 && buff[j] != ' ' && buff[j] != '.'; temp[i++] = buff[j++]);
    temp[i + 0] = '\0';
    wsecs = atoi(temp);

	if ( timelong == 1 )
    	snprintf(tokn, _VPW_CHARS257, "%s%2d%2d%2d", timepref, whour, wmins, wsecs);
	else
    	snprintf(tokn, _VPW_CHARS257, "%s%2d%2d", timepref, whour, wmins);


    for (i = 0; tokn[i] != '\0'; i++) {
        if (tokn[i] == ' ')
            tokn[i] = '0';
    }

    strcpy(values[_VPW_JESTIME], tokn);

    /* System NAME */
    for (i = 0, j = _VPW_SYSNAME_OFF;
         i < _VPW_SYSNAME_LEN && buff[j] != ' '; tokn[i++] = buff[j++]);
    tokn[i + 0] = '\0';
    strcpy(values[_VPW_SYSNAME], tokn);

    return type;
}

#endif
