#ifndef _VPWPC_C
#define _VPWPC_C

//----------------------------------------------------------------------
// vpwpc.c _VPW_VERSIONSTRING
// (c) copyright Enrico Sorichetti, 2004-2007
// Released under the "Q Public license"
//----------------------------------------------------------------------
//

#define _VPW_MAIN

#include "vpwpc.h"

#include <pdflib.h>

#include "vpwpdf.h"

#include <getopt.h>

void xusage()
{
    fprintf(stderr, "%-8s - %s %s.\n", prog, version, cpright );
    fprintf(stderr, "%-8s - %s.\n", prog, license );
    fprintf(stderr, "%-8s - options :\n", prog);
    fprintf(stderr, "%-8s   -h/--help     \n", prog);
    fprintf(stderr, "%-8s   -V/--version  \n", prog);
    fprintf(stderr, "%-8s   -q/--quiet    (flag) \n", prog);
    fprintf(stderr, "%-8s   -h/--verbose  (flag) \n", prog);           
    fprintf(stderr, "%-8s   -i/--inifile  (data) \n", prog);
    fprintf(stderr, "%-8s   -l/--logfile  (data)\n",  prog);
    fprintf(stderr, "%-8s   -t/--logsuff  (data)\n",  prog);

    fprintf(stderr, "%-8s   -s/--spooldir (data) \n", prog);
    fprintf(stderr, "%-8s   -p/--prgrname (data) \n", prog);

    fprintf(stderr, "%-8s     /--2chars   (flag)\n",  prog);
    fprintf(stderr, "%-8s     /--3chars   (flag)\n",  prog);

	exit (0) ;

}

void xversion()
{
    fprintf(stderr, "%-8s - %s.\n", prog, cpright );
    fprintf(stderr, "%-8s - %s.\n", prog, license );
    fprintf(stderr, "%-8s - Version : %s.\n", prog, version);
    fprintf(stderr, "%-8s - Build   : %s.\n", prog, buildid);
    exit(0);
}

int main(int argc, char *argv[])
{

	char 	work[_VPW_CHARS257] ;

	time_t	worktime ;

	worktime = time(NULL) ;
	strftime(log0date, sizeof(log0date), "%y/%m/%d", localtime(&worktime)) ;
	strftime(log0time, sizeof(log0time), "%H:%M:%S", localtime(&worktime)) ;

    int vpwpc_rc = 0;

    char filename[_VPW_CHARS257] = "";
    FILE *file;
    int fileopen = 0;
    int filemode = _VPW_TXTMODE ;

	int star_done = 0 ;

    int have_buff = 0;
    char hasp_buff[_VPW_BUFF1024] = "";
    char prev_buff[_VPW_BUFF1024] = "";
    char *cntl_char;
    int buff_indx = 0;

    char buff[_VPW_BUFF1024] = "";
    char prev[_VPW_BUFF1024] = "";

    pid_t vpwpcpid;

    int buffno = 0;
    int lineno = 0;
    int lostno = 0;

    char filehead[_VPW_CHARS257] = "";
    char filetail[_VPW_CHARS257] = "";

	char filemask[_VPW_CHARS257] = "";
	char filepatt[_VPW_CHARS257] = "";

    struct stat filestat;

    char temp[_VPW_CHARS257];
    char tokn[_VPW_CHARS257];
    char term[_VPW_CHARS257];

    int i, j, l;

    int hasp_type;
    int indx, ipatt, itokn, ikeyw;

    int dupflag = 0;
    int idxflag = 0;
    int kwdflag = 0;

	int blkflag,blkleng;
	char blktext[_VPW_BLKWIDTH+1] ;

	int optindx;

    static struct option optlong[] = {
        {"help", 		no_argument, 		0, 			'h'},
        {"version", 	no_argument, 		0, 			'V'},	
        {"quiet", 		no_argument, 		&msglevel,  0},
        {"verbose", 	no_argument, 		&msglevel,  1},
        {"inifile", 	required_argument,  &opt0flag,  'i'},
        {"logfile", 	required_argument,  &opt0flag,  'l'},
        {"logsuff", 	required_argument,  &opt0flag,  't'},
        {"spooldir", 	required_argument,  &opt0flag,  's'},
        {"prgrname", 	required_argument,  &opt0flag,  'p'},
        {"2chars",		no_argument,		&stdwidth,  _VPW_2CHARS},
        {"3chars",		no_argument,		&stdwidth,  _VPW_3CHARS},
        {0, 0, 0, 0}
    };

    int opt;
    while ((opt = getopt_long(argc, argv, ":hVqvi:l:t:s:p:",
                              optlong, &optindx)) != -1) {

        switch (opt) {
        case 0: 
			switch (opt0flag) {
				case 'i':
					if  ( strlen(optarg) > 0 ) {
            			strcpy(ini0file, optarg);
            			ini0flag = 1;
					}						
					break;			
				case 'l':
					if  ( strlen(optarg) > 0 ) {
            			strcpy(log0pref, optarg);
            			log0flag = 1;
					}						
					break;	
				case 't':
					if  ( strlen(optarg) > 0 ) {
            			strcpy(log0suff, optarg);
					}						
					break;	
				case 's':
					if  ( strlen(optarg) > 0 ) {
            			strcpy(spooldir, optarg);
					}						
					break;
				case 'p':
					if  ( strlen(optarg) > 0 ) {
            			strcpy(prgrname, optarg);
					}						
					break;			

				default:
					break;			
			}
            break;
        case 'h':
            xusage();
            break;
        case 'V':
            xversion();
            break;
        case 'q':
            msglevel = 0;
            break;
        case 'v':
            msglevel = 1;
            break;
        case 'i':
			if ( optarg[0] == '-' ) {
            	fprintf(stderr,
                    	"%-8s - option \'%c\' requires an argument.\n",
                    	prog, opt);
           		 xusage();
			}
            strcpy(ini0file, optarg);
            ini0flag = 1;
            break;
        case 'l':
			if ( optarg[0] == '-' ) {
            	fprintf(stderr,
                    	"%-8s - option \'%c\' requires an argument.\n",
                    	prog, opt);
           		 xusage();
			}
            strcpy(log0pref, optarg);
            log0flag = 1;
            break;
        case 't':
			if ( optarg[0] == '-' ) {
            	fprintf(stderr,
                    	"%-8s - option \'%c\' requires an argument.\n",
                    	prog, opt);
           		 xusage();
			}
            strcpy(log0suff, optarg);
            break;
        case 's':
			if ( optarg[0] == '-' ) {
            	fprintf(stderr,
                    	"%-8s - option \'%c\' requires an argument.\n",
                    	prog, opt);
           		xusage();
			}
            strcpy(spooldir, optarg);
            break;
        case 'p':
			if ( optarg[0] == '-' ) {
            	fprintf(stderr,
                    	"%-8s - option \'%c\' requires an argument.\n",
                    	prog, opt);
           		xusage();
			}
            strcpy(prgrname, optarg);
            break;
        case ':':
            fprintf(stderr,
                    "%-8s - option \'%c\' requires an argument.\n",
                    prog, optopt);
            xusage();
            break;
        case '?':
            fprintf(stderr,
                    "%-8s - option \'%c\' not supported.\n", prog, optopt);
            xusage();
            break;
        default:
            xusage();
        }
    }

	if ( msglevel > 0 ) {
    	printf("%-8s - Started %s.\n", prog, log0time);
    	printf("%-8s - %s %s .\n", prog, version, cpright  );
	}

	if  (log0flag) {

		l = strlen(log0pref);
		if 	( log0pref[l-1] == '*' ) 
			log0pref[l-1] = '_' ;

		vpwpcpid = getpid(); 
		strftime(work, sizeof(work), "%y%m%d-%H%M%S", localtime(&worktime));

		if 	( log0pref[l-1] == '_'  || log0pref[l-1] == '-') 
			snprintf(log0file, _VPW_CHARS257, "%s%s_%5.5i", log0pref, work, vpwpcpid);
		else
			snprintf(log0file, _VPW_CHARS257, "%s_%5.5i", log0pref, vpwpcpid);

		if 	( strlen(log0suff) > 0 ) {
			strcat(log0file,log0suff);
		}

		log0 = fopen(log0file, "wt");
		if  (log0 != NULL) {
			if ( msglevel ) 
				printf("%-8s - Using LogFile '%s'.\n", prog,log0file) ;

			fprintf(log0,	"%s - %-8s Started\n", log0time, prog);
			fprintf(log0,	"%s - %-8s Copyright Enrico Sorichetti, 2004-2007.\n",log0time, prog);
			fprintf(log0,	"%s - %-8s Version : %s.\n", log0time, prog, version);
			fprintf(log0,	"%s - %-8s Build   : %s.\n", log0time, prog, buildid);

		}
		else {
			fprintf(stderr, "%-8s - Unable to open LogFile '%s'.\n", prog,log0file);
			fprintf(stderr, "%-8s - Continuing without a log.\n", prog);
		}

	} 

	if  (ini0flag) {
		ini0 = fopen(ini0file, "rt");
		if  (ini0 != NULL) {
			if ( msglevel ) 
				printf("%-8s - Using IniFile '%s'.\n", prog,ini0file);

			if ( log0 ) 
				fprintf(log0,	"%s - %-8s Using IniFile '%s'.\n", log0time, prog, ini0file);
		} 
		else {
			fprintf(stderr, "%-8s - Unable to open IniFile '%s'.\n", prog, ini0file);
			fprintf(stderr, "%-8s - Continuing using default patterns.\n", prog);

			if ( log0 ) {
				fprintf(log0,	"%s - %-8s Unable to open IniFile '%s'.\n", log0time, prog, ini0file);
				fprintf(log0,	"%s - %-8s Continuing using default patterns.\n", log0time, prog);
			}
		}
	} 

    vpwini();

    have_buff = 0;
    hasp_buff[0] = '\0';

    for (buffno = 0, lineno = 0, lostno = 0;;) {

        // Horrid hack due to the presence in the sysout files of
        // dangling control characters interspersed in lines
        // I discovered the problem thanks to the mf1 outputs
        if (have_buff == 0) {
            for (j = 0; j < _VPW_BUFF1024; buff[j++] = '\0');
            fgets(hasp_buff, _VPW_BUFF1024, stdin);
            if (feof(stdin))
                break;
            have_buff = 1;
            buffno++;
        }
        // printf("%-8s - buff read.\n", prog);
        // printf("%-8s - buff len (%d).\n", prog, strlen(hasp_buff));
        // printf("%-8s - buff data>%s<.\n", prog, hasp_buff);

        do  {
            if (hasp_buff[0] == '\f') {
                have_buff = 0;
                strcpy(buff, hasp_buff);
                // printf("%-8s - no cleanup needed.\n", prog);
                break;
            }
            if ((cntl_char = strchr(hasp_buff, '\f')) != NULL) {
                buff_indx = cntl_char - hasp_buff;
                for (i = 0, j = 0; j < buff_indx; buff[i++] = hasp_buff[j++]);
                buff[i + 0] = '\0';
                for (i = 0, j = buff_indx;
                     j < _VPW_BUFF1024 && hasp_buff[j] != '\0';
                     hasp_buff[i++] = hasp_buff[j++]);
                hasp_buff[i + 0] = '\0';
                break;
            }
            else {
                have_buff = 0;
                strcpy(buff, hasp_buff);
                break;
            }

        }	while (0) ;
        // end of
        // Horrid hack

        lineno++;

        for (j = 0;
             j < _VPW_BUFF1024 && buff[j] != '\0'
             && buff[j] != '\n' && buff[j] != '\r'; j++);
        // printf("%-8s - buffer cleaned.\n", prog);

        hasp_type = vpwpars(buff);
        switch (hasp_type) {

        case _VPW_JES_DATA	:
            /* not "****" */
            if (fileopen == 0) {
//				printf("%-8s - lost buffer ( 0 )-%s.\n", prog,buff) ;
                lostno++;
                continue;
            }

			switch (filemode) {
			case _VPW_PDFMODE:
        		buff[j + 0] = '\0';
  		   		i = j = 0 ;
	            if (buff[0] == '\f') {
  	            	if ( ycurr != page_height - tmargin ) {
	                	PDF_end_page_ext(p,"");
        				ycurr = page_height - tmargin ;
                	}
					j = 1;
                }
        		if ( ycurr < bmargin ) {
        			PDF_end_page_ext(p,"");
        			ycurr = page_height - tmargin ;
  	         	}
  	            if ( ycurr == page_height - tmargin ) {
	    			PDF_begin_page_ext(p, page_width, page_height, "");
	    			font = PDF_load_font(p, fontname, 0, encoding, "");
	    			PDF_setfont(p, font, fontsize);
	    			PDF_set_text_pos(p, lmargin, ycurr) ;
	    		}
            	for (; j < _VPW_BUFF1024 && buff[j] != '\0';
                	temp[i++] = buff[j++]);
            	temp[i + 0] = '\0';
				PDF_continue_text(p,temp) ;
				ycurr -= fontsize;
				continue ;
			break;
			default :
			    buff[j + 0] = '\n';
        		buff[j + 1] = '\0';
            	fputs(buff, file);
            	continue;
           	break;
			}

            continue;
            break;

        case _VPW_JES_START :
        case _VPW_JES_CONT  :
            /* START/CONT */

			if 	(strcmp(buff,prev) == 0 ) {
				break ;
			}
			strcpy(prev,buff);

            if 	(fileopen != 0) {
            	/* something went wrong ( no trailer ) */
				switch (filemode) {
				case _VPW_PDFMODE:
				    if (ycurr != page_height - tmargin)
						PDF_end_page_ext(p, "");
    				PDF_end_document(p, "");
    				PDF_delete(p);
                	fileopen = 0;
				break;
				default :
                	fclose(file);
                	fileopen = 0;
				break ;
				}
            }

            do	{

				filemask[0] = '\0' ;
				filepatt[0] = '\0' ;

                /* jobtype_jesclas */
                temp[0] = '\0' ;
                strcat(temp, values[_VPW_JOBTYPE]);
                strcat(temp, "_");
                strcat(temp, values[_VPW_JESCLAS]);

                for (i = 0; temp[i] != '\0'; i++)
                    temp[i] = tolower(temp[i]);
                for (i = 0; i < maskcoun; i++) {
                    if (strcasecmp(maskname[i], temp) == 0) {
                        strcpy(filemask, maskname[i]);
                        strcpy(filepatt, maskpatt[i]);
                        break;
                    }
                }
                if (filepatt[0] != '\0')
                    break;

                /* jobtype mask */
                temp[0] = '\0' ;
                strcat(temp, values[_VPW_JOBTYPE]);

				for (i = 0; temp[i] != '\0'; i++)
                    temp[i] = tolower(temp[i]);
                for (i = 0; i < maskcoun; i++) {
                    if (strcasecmp(maskname[i], temp) == 0) {
                        strcpy(filemask, maskname[i]);
                        strcpy(filepatt, maskpatt[i]);
                        break;
                    }
                }
                if (filepatt[0] != '\0')
                    break;

                /* jesclas */
                temp[0] = '\0' ;
                strcat(temp, values[_VPW_JESCLAS]);

                for (i = 0; temp[i] != '\0'; i++)
                    temp[i] = tolower(temp[i]);
                for (i = 0; i < maskcoun; i++) {
                    if (strcasecmp(maskname[i], temp) == 0) {
                        strcpy(filemask, maskname[i]);
                        strcpy(filepatt, maskpatt[i]);
                        break;
                    }
                }
                if (filepatt[0] != '\0')
                    break;

                /* default-user */
                strcpy(temp, "*");

                for (i = 0; temp[i] != '\0'; i++)
                    temp[i] = tolower(temp[i]);
                for (i = 0; i < maskcoun; i++) {
                    if (strcasecmp(maskname[i], temp) == 0) {
                        strcpy(filemask, maskname[i]);
                        strcpy(filepatt, maskpatt[i]);
                        break;
                    }
                }
                if (filepatt[0] != '\0')
                    break;


                /* default-builtin */
                strcpy(filemask, dfltmask);
				strcpy(filepatt, dfltpatt);
                break;
            }	while (0) ;

            dupflag = 0;
            idxflag = 0;
			filename[0] = '\0' ;
			filehead[0] = '\0' ;
			filetail[0] = '\0' ;

            for (ipatt = 0;;) {
                for (itokn = 0; itokn < _VPW_CHARS257; tokn[itokn++] = '\0');
                for (itokn = 0;
                    filepatt[ipatt] != '/' && filepatt[ipatt] != '-' && 
					filepatt[ipatt] != '_' && filepatt[ipatt] != '.' && 
					filepatt[ipatt] != '\0';
                    tokn[itokn++] = filepatt[ipatt++]);
                tokn[itokn + 0] = '\0';
                term[0] = filepatt[ipatt++];
                term[1] = '\0';

                kwdflag = 0;
                for (ikeyw = 0; ikeyw < _VPW_KWORDS; ikeyw++) {
                    if (strcasecmp(tokn, kwords[ikeyw]) == 0) {
                        strcat(filetail, values[ikeyw]);
                        kwdflag = 1;
                        break;
                    }
                }

				if (kwdflag == 0) {
                	if (strcasecmp(tokn, "dupindx") == 0) {
                    	dupflag = 1;
						idxflag = 0;
                    	strcpy(filehead, filetail);
                    	filetail[0] = '\0';
                	}
					else
                	if (strcasecmp(tokn, "dsnindx") == 0) {
                    	dupflag = 1;
						idxflag = 1;
                    	strcpy(filehead, filetail);
                    	filetail[0] = '\0';
                	}
					else
                    	strcat(filetail, tokn);
                }

                for (i = 0; filehead[i] != '\0'; i++)
                    filehead[i] = tolower(filehead[i]);
                for (i = 0; filetail[i] != '\0'; i++)
                    filetail[i] = tolower(filetail[i]);

                switch (term[0]) {
                case '/':
                    if (strcmp(filetail, "") == 0) {
                        strcat(filetail, "/");
                        break;
                    }
                    if (stat(filetail, &filestat) == -1)
#ifdef __WIN32__
	                    mkdir(filetail);
#else
	                    mkdir(filetail, S_IRWXU | S_IRWXG | S_IRWXO);
#endif
                    strcat(filetail, "/");
                    break;
                case '_':
                    strcat(filetail, "_");
                    break;
                case '-':
                    strcat(filetail, "-");
                    break;
                case '.':
                    strcat(filetail, ".");
                    break;
                case '\0':
                    break;
                default:
                    break;
                }

                if (term[0] == '\0')
                    break;

            }

            if (dupflag == 1) {
                for (indx = 1;; indx++) {
                    strcpy(filename, filehead);

					if ( (idxflag == 0) && (indx == 1) ) {
						i = strlen(filename);
						filename[i-1] = '\0' ;
					}
					else {
                    	snprintf(temp, _VPW_CHARS257, "%5d", indx);
                    	for (i = 0; temp[i] != '\0'; i++) {
                        	if (temp[i] == ' ')
                            	temp[i] = '0';
                    	}
                    	strcat(filename, temp);
                    }
					strcat(filename, filetail);
                    if (stat(filename, &filestat) == -1)
                        break;
                }
            }
            else
                strcpy(filename, filetail);

			filemode = _VPW_TXTMODE;
			if ( strcasecmp(tokn,pdfsuff) == 0 )
				filemode = _VPW_PDFMODE;

            if  ( log0 ) {
				worktime = time(NULL) ;
				strftime(log0time, sizeof(log0time), "%H:%M:%S", localtime(&worktime)) ;
                fprintf(log0,
                        "%s - %-8s Spooling :\'%s\' \'%-8s\' \'%s\'\n%s\'%s\'\n%s\'%s\'\n",
                        log0time, prog , 
						values[_VPW_JESCLAS], values[_VPW_JOBNAME], values[_VPW_JOBNUMB],
                        "                    Mask     :", filepatt, 
						"                    File     :", filename);
			}

			switch (filemode) {
			case _VPW_PDFMODE:
				fileopen = 1 ;
			    buff[j + 0] = '\0';
	    		p = PDF_new();
    			if (p == NULL) {
					fprintf(stderr, "Error: cannot initialize PDFLib.\n");
					exit(1);
    			}
    			PDF_begin_document(p, filename, 0, "");
    			PDF_set_value(p,"compress",compress);
				PDF_set_info(p, "Title", "MVS38J Sysout");
    			PDF_set_info(p, "Creator", _VPW_PROGRAM );

    			ycurr = page_height - tmargin;
    			PDF_begin_page_ext(p, page_width, page_height, "");
	    		font = PDF_load_font(p, fontname, 0, encoding, "");
	    		PDF_setfont(p, font, fontsize);
	   			PDF_set_text_pos(p, lmargin, ycurr) ;

	   			i = j = 0 ;
	            if (buff[0] == '\f')
                	j = 1;

            	for (; j < _VPW_BUFF1024 && buff[j] != '\0';
                	temp[i++] = buff[j++]);
            	temp[i + 0] = '\0';

            	for (i = 0; i < _VPW_BRKLINES; i++) {
                	PDF_continue_text(p, temp);
					ycurr -= fontsize;
				}

            	for (i = 0; i < _VPW_BRKLINES; i++) {
                    PDF_continue_text(p, " ");
					ycurr -= fontsize;
				}

				strcpy(blktext,values[_VPW_JOBNAME]);
				blkleng = strlen(blktext) ;
				blkflag = 1 ;

				vpwblpr(blkflag, blkleng, blktext ) ;

            	for (i = 0; i < _VPW_BLHEIGHT; i++) {
                	PDF_continue_text(p, blkstak[i]);
					ycurr -= fontsize;
				}

            	for (i = 0; i < _VPW_BRKLINES; i++) {
                    PDF_continue_text(p, " ");
					ycurr -= fontsize;
				}

				blktext[0] = values[_VPW_JOBTYPE][0] ;
				for (i=1, j=3; values[_VPW_JOBNUMB][j] != '\0';
					 blktext[i++] = values[_VPW_JOBNUMB][j++] ) ;
				blktext[i++] = ' ' ;
				blktext[i++] = values[_VPW_JESCLAS][0] ;
				blktext[i++] = '\0' ;
				blkleng = strlen(blktext) ;
				blkflag = 0 ;

				vpwblpr(blkflag, blkleng, blktext ) ;

            	for (i = 0; i < _VPW_BLHEIGHT; i++) {
                	PDF_continue_text(p, blkstak[i]);
					ycurr -= fontsize;
				}

				PDF_end_page_ext(p, "");
    			ycurr = page_height - tmargin;

            	continue;

			break;
			default :
			    buff[j + 0] = '\n';
        		buff[j + 1] = '\0';

            	file = fopen(filename, "wt");
            	fileopen = 1;

            	if (buff[0] == '\f') {
            		for (i = 0, j = 1; j < _VPW_BUFF1024 && buff[j] != '\0';
                		temp[i++] = buff[j++]);
            		temp[i + 0] = '\0';
				}
				else {
					strcpy(temp,buff) ;
					buff[0] = '\f' ;
					buff[1] = '\0' ;
					strcat(buff,temp) ;
				}

            	fputs(buff, file);
            	for (i = 0; i < _VPW_BRKLINES - 1; i++)
                	fputs(temp, file);
            	continue;

			break ;
			}

            break;

        case _VPW_JES_END	:
            /* END */

			if 	(strcmp(buff,prev) == 0 ) {
				break ;
			}
			strcpy(prev,buff);

			if (fileopen == 0) {
//				printf("%-8s - lost buffer ( 3 ) -%s.\n", prog,buff) ;
                lostno++;
                continue;
            }

			switch (filemode) {
			case _VPW_PDFMODE:
			    buff[j + 0] = '\0';
				if (ycurr != page_height - tmargin) {
					PDF_end_page_ext(p, "");
    				ycurr = page_height - tmargin;
				}

    			PDF_begin_page_ext(p, page_width, page_height, "");
	    		font = PDF_load_font(p, fontname, 0, encoding, "");
	    		PDF_setfont(p, font, fontsize);
	   			PDF_set_text_pos(p, lmargin, ycurr) ;

	   			i = j = 0 ;
	            if (buff[0] == '\f')
                	j = 1;

            	for (; j < _VPW_BUFF1024 && buff[j] != '\0';
                	temp[i++] = buff[j++]);
            	temp[i + 0] = '\0';

            	for (i = 0; i < _VPW_BRKLINES; i++) {
                	PDF_continue_text(p, temp);
					ycurr -= fontsize;
				}

				if (ycurr != page_height - bmargin)
					PDF_end_page_ext(p, "");

    			PDF_end_document(p, "");
    			PDF_delete(p);
				fileopen = 0;
				continue ;
			break;
			default :
			    buff[j + 0] = '\n';
        		buff[j + 1] = '\0';

            	fputs(buff, file);
            	i = j = 0;
            	if (buff[0] == '\f')
                	j = 1;
            	for (; j < _VPW_BUFF1024 && buff[j] != '\0';
                	temp[i++] = buff[j++]);
            	temp[i + 0] = '\0';
            	for (i = 0; i < _VPW_BRKLINES- 1; i++)
                	fputs(temp, file);
            	fclose(file);
            	fileopen = 0;
            	continue;
            break;
			}
			break;
        default:
            /* Should not occur */
            fprintf(stderr, "%-8s - Logic error \n", prog);
            fprintf(stderr, "%-8s - Ended Rc(9999).\n", prog);
            exit(9999);
        }

    }

	if (fileopen != 0) {
    	/* something went wrong ( no trailer ) */
		switch (filemode) {
		case _VPW_PDFMODE:
			if (ycurr != page_height - tmargin)
				PDF_end_page_ext(p, "");
    		PDF_end_document(p, "");
    		PDF_delete(p);
            fileopen = 0;
			break;
		default :
          	fclose(file);
           	fileopen = 0;
			break ;
		}
    }

	worktime = time(NULL) ;
	strftime(log0time, sizeof(log0time), "%H:%M:%S", localtime(&worktime)) ;

    if ( log0 ) {
        fprintf(log0, "%s - %-8s Ended Rc(%d).\n", log0time, prog, vpwpc_rc);
        fclose(log0);
    }

	if  ( msglevel ) 
    	printf("%-8s - Ended   %s Rc(%d).\n", prog, log0time, vpwpc_rc);

	exit(vpwpc_rc) ;

}
#endif
