#ifndef _VPWPC_H
#define _VPWPC_H

//----------------------------------------------------------------------
// vpwpc.h _VPW_VERSIONSTRING 
// (c) copyright Enrico Sorichetti, 2004-2007
// Released under the "Q Public license"
//----------------------------------------------------------------------
//

#ifdef 	_VPW_MAIN
#define _VPW_EXTERN
#define _VPW_CONST
#else
#define _VPW_EXTERN extern
#define _VPW_CONST 	const
#endif

#define _VPW_PROGRAM	"vpwpc"
_VPW_EXTERN const char *prog
#ifdef _VPW_MAIN
    = _VPW_PROGRAM
#endif
    ;

#define _VPW_VERSION	"v02.00 "
_VPW_EXTERN const char *version
#ifdef _VPW_MAIN
    = _VPW_VERSION
#endif
    ;

_VPW_EXTERN const char *cpright
#ifdef _VPW_MAIN
    = "(c) Copyright Enrico Sorichetti, 2004-2007"
#endif
    ;
_VPW_EXTERN const char *license
#ifdef _VPW_MAIN
    = "Released under the 'Q Public license' "
#endif
    ;

_VPW_EXTERN const char *buildid
#ifdef _VPW_MAIN
#ifdef _VPW_ARCH
    = __DATE__ " " __TIME__ " arch(" _VPW_ARCH ") "
#else
    = __DATE__ " " __TIME__ " " 
#endif
#endif
    ;

_VPW_EXTERN int  opt0flag
#ifdef _VPW_MAIN
    = 0
#endif
	;

#define _VPW_CHARS21        21
_VPW_EXTERN char log0date[_VPW_CHARS21] ;

_VPW_EXTERN char log0time[_VPW_CHARS21] ;


#define _VPW_BRKLINES       4

#define _VPW_CHARS257       257
#define _VPW_BUFF1024       1024

#define _VPW_TRIGGER_LEN    4
#define _VPW_TRIGGER_OFF    0
#define _VPW_TRIGGER_OFF_2 	128
#define _VPW_TRIGGER_VAL    "****"

#define _VPW_JESCLAS_LEN    1
#define _VPW_JESCLAS_OFF    4
#define _VPW_JESCLAS_OFF_2  127

#define _VPW_HDRTYPE_LEN    5
#define _VPW_HDRTYPE_OFF    7
#define _VPW_HDRTYPE_OFF_2 	120
#define _VPW_HDRTYPE_NUM    3 ;

#define _VPW_JOBTYPE_LEN    3
#define _VPW_JOBTYPE_OFF    14
#define _VPW_JOBTYPE_OFF_2  110

#define _VPW_JOBNUMB_LEN    8
#define _VPW_JOBNUMB_OFF    14
#define _VPW_JOBNUMB_OFF_2  110

#define _VPW_JOBNAME_LEN    8
#define _VPW_JOBNAME_OFF    24

#define _VPW_PRGNAME_LEN    20
#define _VPW_PRGNAME_OFF    34

#define _VPW_TAGROOM_LEN    4
#define _VPW_TAGROOM_OFF    56
#define _VPW_TAGROOM_VAL    "ROOM"

#define _VPW_JESROOM_LEN    4
#define _VPW_JESROOM_OFF    61

#define _VPW_JESTIME_LEN    11
#define _VPW_JESTIME_OFF    67

#define _VPW_JESDATE_LEN    9
#define _VPW_JESDATE_OFF    79

#define _VPW_TAGUNIT_LEN    7
#define _VPW_TAGUNIT_OFF    90
#define _VPW_TAGUNIT_VAL    "PRINTER"

#define _VPW_TAGXSYS_LEN    3
#define _VPW_TAGXSYS_OFF    100
#define _VPW_TAGXSYS_VAL    "SYS"

#define _VPW_SYSNAME_LEN    4
#define _VPW_SYSNAME_OFF    104

#include <stdlib.h>

#include <string.h>

#include <stdio.h>

#include <sys/types.h>

#include <sys/stat.h>

#include <time.h>

_VPW_EXTERN const char *trigger
#ifdef _VPW_MAIN
    = _VPW_TRIGGER_VAL
#endif
    ;

_VPW_EXTERN const char *tagroom
#ifdef _VPW_MAIN
    = _VPW_TAGROOM_VAL
#endif
    ;

_VPW_EXTERN const char *tagunit
#ifdef _VPW_MAIN
    = _VPW_TAGUNIT_VAL
#endif
    ;

_VPW_EXTERN const char *tagxsys
#ifdef _VPW_MAIN
    = _VPW_TAGXSYS_VAL
#endif
    ;

_VPW_EXTERN char spooldir[_VPW_CHARS257]
#ifdef _VPW_MAIN
    = "spool"
#endif
;

_VPW_EXTERN char prgrname[_VPW_CHARS21]
#ifdef _VPW_MAIN
    = "programmer_name"
#endif
;

_VPW_EXTERN int  datelong
#ifdef _VPW_MAIN
    = 0
#endif
;

_VPW_EXTERN char datepref[_VPW_CHARS21]
#ifdef _VPW_MAIN
    = ""
#endif
;

_VPW_EXTERN int timelong
#ifdef _VPW_MAIN
    = 0
#endif
;

_VPW_EXTERN char timepref[_VPW_CHARS21]
#ifdef _VPW_MAIN
    = ""
#endif
;
          
#define _VPW_2CHARS 2        
#define _VPW_3CHARS 3        
_VPW_EXTERN int stdwidth
#ifdef _VPW_MAIN
    = _VPW_3CHARS
#endif
;

#define _VPW_KWORDS 9
enum hasp_kwords
	{
    _VPW_JESCLAS,
    _VPW_JESDATE,
    _VPW_JESROOM,
    _VPW_JESTIME,
    _VPW_JOBNAME,
    _VPW_JOBNUMB,
    _VPW_JOBTYPE,
    _VPW_PRGNAME,
    _VPW_SYSNAME,
	};


_VPW_EXTERN const char kwords[_VPW_KWORDS][_VPW_CHARS21]
#ifdef _VPW_MAIN
    = {
    "JESCLAS",
    "JESDATE",
    "JESROOM",
    "JESTIME",
    "JOBNAME",
    "JOBNUMB",
    "JOBTYPE",
    "PRGNAME",
    "SYSNAME"
	}
#endif
;

_VPW_EXTERN char values[_VPW_KWORDS][_VPW_CHARS21]
#ifdef _VPW_MAIN
    = {
    "JESCLAS",
    "JESDATE",
    "JESROOM",
    "JESTIME",
    "JOBNAME",
    "JOBNUMB",
    "JOBTYPE",
    "PRGNAME",
    "SYSNAME"
	}
#endif
;

_VPW_EXTERN int  maskcoun
#ifdef _VPW_MAIN
    = 0
#endif
;

_VPW_EXTERN char dfltmask[_VPW_CHARS21] ; 
_VPW_EXTERN char dfltpatt[_VPW_CHARS257] ; 

#define _VPW_MAXPATT 20
_VPW_EXTERN char maskname[_VPW_MAXPATT][_VPW_CHARS21] ;
_VPW_EXTERN char maskpatt[_VPW_MAXPATT][_VPW_CHARS257] ;

enum jes_types
{
	_VPW_JES_DATA=0,
    _VPW_JES_START,
    _VPW_JES_CONT,
    _VPW_JES_END
};

#define  _VPW_JESTYPES 3
_VPW_EXTERN const char types[_VPW_JESTYPES][_VPW_CHARS21]
#ifdef _VPW_MAIN
    = {
    "START",
    "CONT",
    "END"
}
#endif
;

#define _VPW_KMONTHS 12
_VPW_EXTERN const char months[ _VPW_KMONTHS + 1][_VPW_CHARS21]
#ifdef _VPW_MAIN
    = {
    "JAN", "FEB", "MAR", "APR", "MAY", "JUN",
    "JUL", "AUG", "SEP", "OCT", "NOV", "DEC", "ERR"
}
#endif
;

#define _VPW_TXTMODE 	1
#define _VPW_PDFMODE	2
_VPW_EXTERN const char pdfsuff[_VPW_CHARS21]
#ifdef _VPW_MAIN
    = {
    "pdf"
}
#endif
;

#define _VPW_LNLENGTH	133

#define _VPW_BLKWIDTH	12
#define _VPW_BLHEIGHT	12

#define _VPW_GAPWIDTH	2

_VPW_EXTERN char blkstak[_VPW_BLHEIGHT][_VPW_LNLENGTH + 1];

_VPW_EXTERN int msglevel
#ifdef _VPW_MAIN
    = 1
#endif
;

_VPW_EXTERN int  ini0flag
#ifdef _VPW_MAIN
    = 0
#endif
;
_VPW_EXTERN char ini0file[_VPW_CHARS257]
#ifdef _VPW_MAIN
    = "" 
#endif
;
_VPW_EXTERN FILE *ini0;
_VPW_EXTERN char ini0buff[_VPW_CHARS257]
#ifdef _VPW_MAIN
    = "" 
#endif
;
_VPW_EXTERN int ini0lbuf
#ifdef _VPW_MAIN
    = 0 
#endif
;

_VPW_EXTERN int  log0flag
#ifdef _VPW_MAIN
    = 0
#endif
;
_VPW_EXTERN char log0pref[_VPW_CHARS257]
#ifdef _VPW_MAIN
    = ""
#endif
;

_VPW_EXTERN char log0suff[_VPW_CHARS257]
#ifdef _VPW_MAIN
    = ""
#endif
;

_VPW_EXTERN char log0file[_VPW_CHARS257]
#ifdef _VPW_MAIN
    = ""
#endif
;
_VPW_EXTERN FILE *log0;

#endif
